//+------------------------------------------------------------------+
//|                                                UltraMomentum.mq5 |
//|                                   Copyright  2008, dm34@mail.ru | 
//|                                    http://www.fxexpert.ru/forum/ | 
//+------------------------------------------------------------------+
//----  
#property copyright "Copyright  2008, dm34@mail.ru"
//----    
#property link "http://www.fxexpert.ru/forum/"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----       4 
#property indicator_buffers 4
//----  3  
#property indicator_plots   3
//+----------------------------------------------+ 
//|                            |
//+----------------------------------------------+
#define RESET 0 //        
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_ARROW
//----       Red
#property indicator_color1  Red
//----    1  1
#property indicator_width1  1
//----   
#property indicator_label1  "Ultra Momentum Speed Down"
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_ARROW
//----         Lime
#property indicator_color2  Lime
//----    2  1
#property indicator_width2  1
//----   
#property indicator_label2 "Ultra Momentum Speed Up"
//+----------------------------------------------+
//|                     |
//+----------------------------------------------+
//----        
#property indicator_type3   DRAW_FILLING
//----        LimeGreen  Tomato
#property indicator_color3  LimeGreen,Tomato
//----   
#property indicator_label3 "Ultra Momentum"
//+-----------------------------------+
//|    CAMA             |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//----    CAMA   SmoothAlgorithms.mqh
CAMA XMA[];
//+-----------------------------------+
//|             |
//+-----------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  // SMA
   MODE_EMA_,  // EMA
   MODE_SMMA_, // SMMA
   MODE_LWMA_, // LWMA
   MODE_JJMA,  // JJMA
   MODE_JurX,  // JurX
   MODE_ParMA, // ParMA
   MODE_T3,    // T3
   MODE_VIDYA, // VIDYA
   MODE_AMA,   // AMA
  }; */
//+-----------------------------------+
//|             |
//+-----------------------------------+  
enum WIDTH
  {
   Width_1=1, // 1
   Width_2,   // 2
   Width_3,   // 3
   Width_4,   // 4
   Width_5    // 5
  };
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum STYLE
  {
   SOLID_,       //  
   DASH_,        //  
   DOT_,         //  
   DASHDOT_,     // - 
   DASHDOTDOT_   // -    
  };
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input int Momentum_Period=14;                       //   Momentum
input ENUM_APPLIED_PRICE Applied_price=PRICE_CLOSE; //  
//----
input Smooth_Method W_Method=MODE_JMA;             //  
input int StartLength=3;                            //                       
input int WPhase=100;                               //  
//----  
input uint Step=5;                                  //   
input uint StepsTotal=10;                           //   
//----
input Smooth_Method SmoothMethod=MODE_JJMA;         //  
input int SmoothLength=3;                           //  
input int SmoothPhase=100;                          //  
//----                          
input uint UpLevel=80;                              //    %%
input uint DnLevel=20;                              //    %%
input color UpLevelsColor=DarkViolet;               //   
input color DnLevelsColor=DarkViolet;               //   
input STYLE Levelstyle=DASHDOTDOT_;                 //  
input WIDTH LevelsWidth=Width_1;                    //                         
//+----------------------------------------------+
//----   ,   
//----      
double BullsBuffer[];
double BearsBuffer[];
double UpBuffer[];
double DnBuffer[];
//----          WPR
int period[];
//----         Momentum
double momentum0[],momentum1[];
//----      
int Momentum_Handle;
//----      
double middle;
uint StTot1,StTot2;
int min_rates_total,min_rates_cci,min_rates_xma;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
int OnInit()
  {
//----     
   int size=int(StepsTotal+3);
   if(ArrayResize(XMA,size)<size) Print("      XMA[]");
   size-=2;
   if(ArrayResize(momentum0,size)<size) Print("      momentum0[]");
   if(ArrayResize(momentum1,size)<size) Print("      momentum1[]");
   if(ArrayResize(period,size)<size) Print("      period[]");

   ZeroMemory(momentum0);
   ZeroMemory(momentum1);
   ZeroMemory(period);

//----  
   for(int sm=int(StepsTotal); sm>=0 && !IsStopped(); sm--) period[sm]=int(StartLength+sm*Step);

   middle=-double(StepsTotal*UpLevel*3.0/1000.0);

//----       
   XMA[0].XMALengthCheck("StartLength", StartLength);
   XMA[0].XMAPhaseCheck("WPhase", WPhase, W_Method);
   XMA[0].XMALengthCheck("SmoothLength", SmoothLength);
   XMA[0].XMAPhaseCheck("SmoothPhase", SmoothPhase, SmoothMethod);

//----     
   min_rates_cci=Momentum_Period;
   min_rates_xma=min_rates_cci+XMA[0].GetStartBars(W_Method,StartLength+Step*StepsTotal,WPhase)+1;
   min_rates_total=min_rates_xma+XMA[0].GetStartBars(SmoothMethod,SmoothLength,SmoothPhase);
   StTot1=StepsTotal+1;
   StTot2=StepsTotal+2;

//----    Momentum
   Momentum_Handle=iMomentum(NULL,0,Momentum_Period,Applied_price);
   if(Momentum_Handle==INVALID_HANDLE)
     {
      Print("      Momentum");
      return(1);
     }

//----    UpBuffer[]   
   SetIndexBuffer(0,DnBuffer,INDICATOR_DATA);
//----       3  min_rates_total
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(0,PLOT_ARROW,110);
//----      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----    ,   
   ArraySetAsSeries(DnBuffer,true);

//----    DnBuffer[]   
   SetIndexBuffer(1,UpBuffer,INDICATOR_DATA);
//----       4  min_rates_total
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(1,PLOT_ARROW,110);
//----      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----    ,   
   ArraySetAsSeries(UpBuffer,true);

//----    BullsBuffer[]   
   SetIndexBuffer(2,BullsBuffer,INDICATOR_DATA);
//----       1  min_rates_total
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//----    ,   
   ArraySetAsSeries(BullsBuffer,true);

//----    BearsBuffer[]   
   SetIndexBuffer(3,BearsBuffer,INDICATOR_DATA);
//----       2  min_rates_total
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//----    ,   
   ArraySetAsSeries(BearsBuffer,true);

//----      
   string shortname="Ultra Momentum";
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,2);

//----     
   IndicatorSetInteger(INDICATOR_LEVELS,2);

   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,StepsTotal*UpLevel/100);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,0,UpLevelsColor);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,0,Levelstyle);
   IndicatorSetInteger(INDICATOR_LEVELWIDTH,0,LevelsWidth);

   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,StepsTotal*DnLevel/100);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,1,DnLevelsColor);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,1,Levelstyle);
   IndicatorSetInteger(INDICATOR_LEVELWIDTH,1,LevelsWidth);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(BarsCalculated(Momentum_Handle)<rates_total
      || rates_total<min_rates_total)
      return(RESET);

//----    
   int to_copy,limit,bar,maxbar1,maxbar2;
   double Momentum[],upsch,dnsch;

//----    maxbar   XMASeries()
   maxbar1=rates_total-1-min_rates_cci;
   maxbar2=rates_total-1-min_rates_xma;

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
      limit=maxbar1;                       //      
   else limit=rates_total-prev_calculated; //      
//----   
   to_copy=limit+2;
//----      
   if(CopyBuffer(Momentum_Handle,0,0,to_copy,Momentum)<=0) return(RESET);

//----    ,     
   ArraySetAsSeries(Momentum,true);

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      for(int sm=int(StepsTotal); sm>=0 && !IsStopped(); sm--)
         momentum0[sm]=XMA[sm].XMASeries(maxbar1,prev_calculated,rates_total,W_Method,WPhase,period[sm],Momentum[bar],bar,true);

      if(bar>maxbar2)
        {
         if(bar) ArrayCopy(momentum1,momentum0,0,0,WHOLE_ARRAY);
         continue;
        }

      upsch=0;
      dnsch=0;
      for(int sm=int(StepsTotal); sm>=0 && !IsStopped(); sm--)
         if(momentum0[sm]>momentum1[sm]) upsch++;
      else                    dnsch++;

      BullsBuffer[bar]=XMA[StTot1].XMASeries(maxbar2,prev_calculated,rates_total,SmoothMethod,SmoothPhase,SmoothLength,upsch,bar,true);
      BearsBuffer[bar]=XMA[StTot2].XMASeries(maxbar2,prev_calculated,rates_total,SmoothMethod,SmoothPhase,SmoothLength,dnsch,bar,true);

      UpBuffer[bar]=EMPTY_VALUE;
      DnBuffer[bar]=EMPTY_VALUE;

      if(BullsBuffer[bar]<BearsBuffer[bar])
        {
         if(BearsBuffer[bar+1]<=BearsBuffer[bar]) DnBuffer[bar]=middle;
         else UpBuffer[bar]=middle;
        }
      else
        {
         if(BullsBuffer[bar+1]<=BullsBuffer[bar]) UpBuffer[bar]=middle;
         else DnBuffer[bar]=middle;
        }

      if(bar) ArrayCopy(momentum1,momentum0,0,0,WHOLE_ARRAY);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
